import { CommonModule } from '@angular/common';
import { Injectable, ChangeDetectionStrategy, Component, Input, ViewChild, defineInjectable, NgModule } from '@angular/core';
import { MatMenuTrigger, MatMenuModule } from '@angular/material';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxMatPopoverService {
    constructor() { }
}
NgxMatPopoverService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgxMatPopoverService.ctorParameters = () => [];
/** @nocollapse */ NgxMatPopoverService.ngInjectableDef = defineInjectable({ factory: function NgxMatPopoverService_Factory() { return new NgxMatPopoverService(); }, token: NgxMatPopoverService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxMatPopoverComponent {
    constructor() {
        this.xPosition = 'after';
        this.yPosition = 'below';
    }
    // for outside call
    /**
     * @return {?}
     */
    open() {
        this.matMenuTrigger.openMenu();
    }
    /**
     * @return {?}
     */
    close() {
        this.matMenuTrigger.closeMenu();
    }
}
NgxMatPopoverComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-mat-popover',
                template: "<mat-menu #popover=\"matMenu\" [xPosition]=\"xPosition\" [yPosition]=\"yPosition\" class=\"ngm-popover\">\n  <ng-template matMenuContent>\n    <span mat-menu-item [disableRipple]=\"true\" (click)=\"$event.stopPropagation()\" class=\"mat-popover\">\n      <!-- popover content begin -->\n      <ng-container *ngTemplateOutlet=\"popoverContent\"></ng-container>\n      <!-- popover content end  -->\n    </span>\n  </ng-template>\n</mat-menu>\n<div [matMenuTriggerFor]=\"popover\">\n  <ng-content></ng-content>\n</div>\n",
                changeDetection: ChangeDetectionStrategy.OnPush,
                exportAs: 'ngxMatPopover'
            }] }
];
NgxMatPopoverComponent.propDecorators = {
    xPosition: [{ type: Input }],
    yPosition: [{ type: Input }],
    popoverContent: [{ type: Input }],
    matMenuTrigger: [{ type: ViewChild, args: [MatMenuTrigger,] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxMatPopoverModule {
}
NgxMatPopoverModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgxMatPopoverComponent],
                imports: [CommonModule, MatMenuModule],
                exports: [NgxMatPopoverComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxMatPopoverService, NgxMatPopoverComponent, NgxMatPopoverModule };

//# sourceMappingURL=ngx-mat-popover.js.map